/*	$Id: builder_factory_registration.h 1728 2005-05-06 08:08:53Z jgressma $
 *
 *  Copyright 2005 University of Potsdam, Germany
 * 
 *	This file is part of Platypus.
 *
 *  Platypus is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Platypus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Platypus; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef BUILDER_FACTORY_REGISTRATION_H
#define BUILDER_FACTORY_REGISTRATION_H

namespace Platypus
{
	class FactoryRegistrationStrategy
	{
	public:
		virtual ~FactoryRegistrationStrategy()
		{}
		void registerWithFactories();
	private:
		virtual void registerOSSpecificTypes() = 0;
	};

	class OSSpecificFactoryRegistration : public FactoryRegistrationStrategy
	{
		void registerOSSpecificTypes();
	};

	class OSSpecificRegistrationFactory
	{
	public:
		static inline FactoryRegistrationStrategy* create()
		{
			return new OSSpecificFactoryRegistration();
		}
	};
}

#endif
