/*	$Id: choice_feeder.h 1728 2005-05-06 08:08:53Z jgressma $
 *
 *  Copyright 2005 University of Potsdam, Germany
 * 
 *	This file is part of Platypus.
 *
 *  Platypus is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Platypus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Platypus; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef CHOICE_FEEDER_H
#define CHOICE_FEEDER_H

#include <platypus/types/choice.h>

namespace Platypus
{
	class Expander;
	class ChoiceFeeder
	{
	public:
		ChoiceFeeder(const DelegatableChoice& choices_to_feed);
		// This c'tor takes ownership of dc passed
		// via swap!!!
		ChoiceFeeder(DelegatableChoice& choices_to_feed);
		void feed(Expander& expander) const;
	private:
		DelegatableChoice choicesToFeed_;
	};
}

#endif
