/*	$Id: delegatable_choice_policy.h 1728 2005-05-06 08:08:53Z jgressma $
 *
 *  Copyright 2005 University of Potsdam, Germany
 * 
 *	This file is part of Platypus.
 *
 *  Platypus is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Platypus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Platypus; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef PLATYPUS_DELEGATABLE_CHOICE_POLICY_IMPL_H
#define PLATYPUS_DELEGATABLE_CHOICE_POLICY_IMPL_H

#include <portablethreads/utility.h>
#include <platypus/types/choices_to_do.h>

namespace Platypus
{
	const char* const DC_POLICY_CHOOSE_RANDOM = "random";
	class ChooseRandomPolicy : public DCPolicy
	{
	public:
		typedef DCPolicy::const_iterator const_iterator;
		ChooseRandomPolicy();
		virtual DCPolicy* clone() const;
		static DCPolicy* create();
	private:
		virtual const_iterator choose(const_iterator begin, const_iterator end);
	private:
		PortableThreads::PRandom rng_;
	};

	const char* const DC_POLICY_CHOOSE_EARLIEST = "choose-earliest";
	class ChooseEarliestPolicy : public DCPolicy
	{
	public:
		typedef DCPolicy::const_iterator const_iterator;
		virtual DCPolicy* clone() const;
		static DCPolicy* create();
	private:
		virtual const_iterator choose(const_iterator begin, const_iterator end);
	};
};

#endif
